package com.hack23.cia.model.common.xml;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.xml.bind.DatatypeConverter;

public class XmlTimeTypeAdapter {

	private static final DateFormat SIMPLE_DATE_FORMAT = new SimpleDateFormat(
			"yyyy-MM-dd");

	public static Date parseDate(String s) {
		if (s == null) {
			return null;
		}
		// hack to supported swedish riksdags xml.
		String dateStr = s.trim();
		if ("2001-01-01 00:00:00".length() == dateStr.length()
				|| "2001-01-01".length() == dateStr.length()) {
			try {
				return SIMPLE_DATE_FORMAT.parse(dateStr.substring(0, 10));
			} catch (ParseException e) {
			}
		}
		return DatatypeConverter.parseDate(s).getTime();
	}

	public static String printDate(Date dt) {
		if (dt == null) {
			return null;
		}
		Calendar c = Calendar.getInstance();
		c.setTime(dt);
		return DatatypeConverter.printDate(c);
	}

	public static Date parseTime(String s) {
		if (s == null) {
			return null;
		}
		return DatatypeConverter.parseTime(s).getTime();
	}

	public static String printTime(Date dt) {
		if (dt == null) {
			return null;
		}
		Calendar c = Calendar.getInstance();
		c.setTime(dt);
		return DatatypeConverter.printTime(c);
	}

	public static Date parseDateTime(String s) {
		if (s == null) {
			return null;
		}
		return DatatypeConverter.parseDateTime(s).getTime();
	}

	public static String printDateTime(Date dt) {
		if (dt == null) {
			return null;
		}
		Calendar c = Calendar.getInstance();
		c.setTime(dt);
		return DatatypeConverter.printDateTime(c);
	}
}
